package phonebook;

import phonebook.model.PhoneBookModel;
import phonebook.view.extended.PhoneBookExtendedGUIView;
import phonebook.view.simple.MessagePane;
import phonebook.view.simple.PhoneBookSimpleGUIView;


/**
 * Used by the MSDCompiler runtime. Provides references for system objects, or singeltons. 
 * @author asafk
 */
public class MSDEnv
{
	static PhoneBookView view = null;
	static PhoneBookModel model = null;
	static PhoneBookController controller = null;
	static MessagePane messagePane = null;
	
	static void setView(PhoneBookView view)
	{
		MSDEnv.view = view;
		if(view instanceof PhoneBookSimpleGUIView)
			MSDEnv.messagePane = ((PhoneBookSimpleGUIView)view).getMessagePane();
		if(view instanceof PhoneBookExtendedGUIView)
			MSDEnv.messagePane = ((PhoneBookExtendedGUIView)view).getMessagePane();
			
	}
	
	static void setModel(PhoneBookModel model)
	{
		MSDEnv.model = model;
	}
	
	static void setController(PhoneBookController control)
	{
		MSDEnv.controller = control;
	}
	
	public static Object getLifeLineInstance(String lineType)
	{
		if(lineType.equals("PhoneBookView"))
			return view;
		if (lineType.equals("PhoneBookModel"))
			return model;
		if (lineType.equals("IView"))
			return view;
		if (lineType.equals("PhoneBookController"))
			return controller;
		if(lineType.equals("IController"))
			return controller;
		if(lineType.equals("MessagePane"))
			return messagePane;
		if(lineType.equals("IModel"))
			return model;
		if(lineType.equals("DBConnector"))
			return model.getDBConnector();
		return null;
	}

}
