//  The file MSDCoordinatorAspect.aj was automatically generated using S2A 0.2 beta.
//	 Usage of the generated code is permitted for non-commercial research and evaluation purposes..
//	 Removing or changing the above comment is prohibited by S2A 0.2 beta license agreement.
//	 For information see http://www.wisdom.weizmann.ac.il/~maozs/s2a/

package phonebook.aspects;

import mvc.interfaces.*;
import phonebook.view.extended.*;
import phonebook.*;
import phonebook.model.*;
import javax.swing.*;
import phonebook.view.simple.*;
import msd.runtime.lib.*;


public aspect MSDCoordinatorAspect
{
	declare precedence: MSDCoordinatorAspect, *;
	ICoordinatorStrategy strategy = new CoordinatorStrategyNaiveImpl();

	private boolean lock = false;
	private int counter = 0;

	public void ViewControll.WrappersetEnabled(InputPane inputPane,Boolean exact_enabled5)
	{
		inputPane.setEnabled(exact_enabled5);
	}

	public void ViewControll.WrapperuserHasInput(PhoneBookController phoneBookController,String symbolic_input)
	{
		phoneBookController.userHasInput(symbolic_input);
	}

	public void ModelControll.WrappercloseConnection(DBConnector dBConnector)
	{
		dBConnector.closeConnection();
	}

	public void ViewControll.WrapperchangeView(MessagePane messagePane,Integer symbolic_state)
	{
		messagePane.changeView(symbolic_state);
	}

	public void PhoneBookController.WrappersetState(PhoneBookModel phoneBookModel,Integer exact_sNine16)
	{
		phoneBookModel.setState(exact_sNine16);
	}

	public void PhoneBookController.WrappersearchPhoneNumber(PhoneBookModel phoneBookModel,String symbolic_input)
	{
		phoneBookModel.searchPhoneNumber(symbolic_input);
	}

	public void PhoneBookController.WrappersetName(PhoneBookModel phoneBookModel,String symbolic_input)
	{
		phoneBookModel.setName(symbolic_input);
	}

	public void ViewControll.Wrapperclear(MessagePane messagePane)
	{
		messagePane.clear();
	}

	public void ModelControll.WrapperstandBy(DBConnector dBConnector)
	{
		dBConnector.standBy();
	}

	public void ModelControll.WrapperstateHasChanged(ViewControll viewControll,Integer symbolic_state)
	{
		viewControll.stateHasChanged(symbolic_state);
	}

	public void PhoneBookController.WrapperaddAnEntry(PhoneBookModel phoneBookModel,String symbolic_input)
	{
		phoneBookModel.addAnEntry(symbolic_input);
	}

	public void PhoneBookController.WrappersaveAll(PhoneBookModel phoneBookModel)
	{
		phoneBookModel.saveAll();
	}

	pointcut MSDMessage():
	call(void *.searchPhoneNumber(..))
	|| call(void *.addAnEntry(..))
	|| call(void *.changeView(..))
	|| call(void *.saveAll(..))
	|| call(void *.closeConnection(..))
	|| call(void *.userHasInput(..))
	|| call(void *.setEnabled(..))
	|| call(void *.setState(..))
	|| call(void *.stateHasChanged(..))
	|| call(void *.setName(..))
	|| call(void *.clear(..))
	|| call(void *.standBy(..));


	after (): MSDMessage()
	{
		MSDAspect.handlingEvent(thisJoinPoint);
		coordinate();
	}

	private void coordinate()
	{
		if (lock)
		{
			counter++;
			return;
		}
		else
		{
			lock = true;
			afterImpl();
			lock = false;
		}
		if(counter>0)
		{
			counter--;
			coordinate();
		}
	}

	private void afterImpl() 
	{
		MSDMethodSet monitoringEnabled = new MSDMethodSet();
		MSDMethodSet executingEnabled = new MSDMethodSet();
		MSDMethodSet coldViolation = new MSDMethodSet();
		MSDMethodSet hotViolation = new MSDMethodSet();

		MSDAspectMVCAbstract.aspectOf().getCutState(monitoringEnabled, executingEnabled, coldViolation, hotViolation);
		MSDAspectUserInput.aspectOf().getCutState(monitoringEnabled, executingEnabled, coldViolation, hotViolation);

		MSDMethod MSDm = strategy.chooseMethod(monitoringEnabled, executingEnabled, coldViolation, hotViolation);

		if(MSDm != null)
		{
			switch (MSDm.messageID)
			{
				case MSDMethods.ViewControll_InputPane_setEnabled:
				 ((ViewControll)MSDm.sourceInstance).WrappersetEnabled(
					(InputPane)MSDm.targetInstance
					,(Boolean)MSDm.args.get(0));
				break;
				case MSDMethods.ViewControll_PhoneBookController_userHasInput:
				 ((ViewControll)MSDm.sourceInstance).WrapperuserHasInput(
					(PhoneBookController)MSDm.targetInstance
					,(String)MSDm.args.get(0));
				break;
				case MSDMethods.ModelControll_DBConnector_closeConnection:
				 ((ModelControll)MSDm.sourceInstance).WrappercloseConnection(
					(DBConnector)MSDm.targetInstance);
				break;
				case MSDMethods.ViewControll_MessagePane_changeView:
				 ((ViewControll)MSDm.sourceInstance).WrapperchangeView(
					(MessagePane)MSDm.targetInstance
					,(Integer)MSDm.args.get(0));
				break;
				case MSDMethods.PhoneBookController_PhoneBookModel_setState:
				 ((PhoneBookController)MSDm.sourceInstance).WrappersetState(
					(PhoneBookModel)MSDm.targetInstance
					,(Integer)MSDm.args.get(0));
				break;
				case MSDMethods.PhoneBookController_PhoneBookModel_searchPhoneNumber:
				 ((PhoneBookController)MSDm.sourceInstance).WrappersearchPhoneNumber(
					(PhoneBookModel)MSDm.targetInstance
					,(String)MSDm.args.get(0));
				break;
				case MSDMethods.PhoneBookController_PhoneBookModel_setName:
				 ((PhoneBookController)MSDm.sourceInstance).WrappersetName(
					(PhoneBookModel)MSDm.targetInstance
					,(String)MSDm.args.get(0));
				break;
				case MSDMethods.ViewControll_MessagePane_clear:
				 ((ViewControll)MSDm.sourceInstance).Wrapperclear(
					(MessagePane)MSDm.targetInstance);
				break;
				case MSDMethods.ModelControll_DBConnector_standBy:
				 ((ModelControll)MSDm.sourceInstance).WrapperstandBy(
					(DBConnector)MSDm.targetInstance);
				break;
				case MSDMethods.ModelControll_ViewControll_stateHasChanged:
				 ((ModelControll)MSDm.sourceInstance).WrapperstateHasChanged(
					(ViewControll)MSDm.targetInstance
					,(Integer)MSDm.args.get(0));
				break;
				case MSDMethods.PhoneBookController_PhoneBookModel_addAnEntry:
				 ((PhoneBookController)MSDm.sourceInstance).WrapperaddAnEntry(
					(PhoneBookModel)MSDm.targetInstance
					,(String)MSDm.args.get(0));
				break;
				case MSDMethods.PhoneBookController_PhoneBookModel_saveAll:
				 ((PhoneBookController)MSDm.sourceInstance).WrappersaveAll(
					(PhoneBookModel)MSDm.targetInstance);
				break;
			}
		}
	}
}

